/*
 *  R : A Computer Langage for Statistical Data Analysis
 *  Copyright (C) 1995, 1996  Robert Gentleman and Ross Ihaka
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Graphics.h"

int GGetIndex(unsigned int col)
{
	return (col & 255);
}


int GSetRGB(unsigned int r, unsigned int g, unsigned int b)
{
	return (r << 8) | (g << 16) | (b << 24);
}


void GGetRGB(unsigned col, int *r, int *g, int *b)
{
	*r = (col >>  8) & 255;
	*g = (col >> 16) & 255;
	*b = (col >> 24) & 255;
}

void GColor(int col)
{
	if(col == NA_INTEGER) col = DP->col;
	if(col != GP->col) {
		DevColor(col);
		GP->col = col;
	}
}
