/*
 *  R : A Computer Langage for Statistical Data Analysis
 *  Copyright (C) 1995, 1996  Robert Gentleman and Ross Ihaka
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Mathlib.h"

#define MAXPLACES 14

double rround(double x, double ndp)
{
	double pow10, sgn, intx;

	ndp = floor(ndp+0.5);
	if (ndp > MAXPLACES)
		ndp = MAXPLACES;
/*	if (ndp < 0.0) ndp = 0.0; */
	pow10 = pow(10.0, ndp);
	sgn = 1.0;
	if(x < 0.0) {
		sgn = -sgn;
		x = -x;
	}
	if (ndp > 0.0) {
		intx = floor(x);
		x = x - intx;
	} else {
		intx = 0.0;
	}
	return sgn * (intx + rint((x*pow10)) / pow10);
}
